import cgi
import wsgiref.handlers

from google.appengine.api import users
from google.appengine.ext import webapp
from google.appengine.ext import db
from google.appengine.ext.webapp import template

import logging

from models import ChipUser
from common import *

class MainPage(webapp.RequestHandler):
  def get(self):
    user = users.get_current_user()
    query = ChipUser.gql("WHERE owner=:user",user=user)
    vals = {user:user.nickname()}
    vals['logout_url'] = users.create_logout_url("/")
    if query.get():
      data = query.get()
      vals['feed'] = "http://" + self.request.headers["Host"] + "/rss/" + str(data.key())
      vals['chipmark_user'] = data.username
    
    render_to_response(self.response, 'templates/index_login.html', vals)

class LinkAccounts(webapp.RequestHandler):
  def post(self):
    user = users.get_current_user()
    username = self.request.get("username")
    password = self.request.get("password")
    query = ChipUser.gql("WHERE owner=:user",user=user)
    if query.get():
      query.get().username = username
      query.get().password = password
      query.get().put()
      self.redirect("/")
    else:
      account = ChipUser(username=username,password=password,owner=user)
      account.put()
      self.redirect("/")

class Delete(webapp.RequestHandler):
  def get(self):
    user = users.get_current_user()
    query = ChipUser.gql("WHERE owner=:user",user=user)
    if query.get():
      query.get().delete()
    self.redirect("/")

def main():
  application = webapp.WSGIApplication(
                                       [('/', MainPage),
                                        ('/link', LinkAccounts),
                                        ('/delete', Delete),
										],debug=True)
  wsgiref.handlers.CGIHandler().run(application)

if __name__ == "__main__":
  main()
